
using System;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Printing;
	
namespace Test
{
	public class HelloPrinter : Form
	{
		public HelloPrinter()
		{
			this.Text = "  ";
			this.Width += 50;
			this.Height /= 2;
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ForeColor = System.Drawing.SystemColors.WindowText;
			this.ResizeRedraw = true;
		}
	
		protected override void OnPaint(PaintEventArgs e)
		{
			Graphics graphics = e.Graphics;
			System.Drawing.StringFormat strfmt = new StringFormat();
			strfmt.Alignment = StringAlignment.Center;
			strfmt.LineAlignment = StringAlignment.Center;
			graphics.DrawString("    !", 
				Font, 
				new SolidBrush(ForeColor),
				RectangleF.FromLTRB(//   Left, Top, Right, Bottom
				this.ClientRectangle.Left,
				this.ClientRectangle.Top,
				this.ClientRectangle.Right,
				this.ClientRectangle.Bottom),
				strfmt);
	
			base.OnPaint (e);
		}
	
		protected override void OnClick(EventArgs e)
		{
			PrintDocument prndoc = new PrintDocument();
			prndoc.DocumentName = this.Text;
			//   
			//  
			prndoc.PrintPage +=new PrintPageEventHandler(prndoc_PrintPage);
			prndoc.Print(); //   (  PrintPage)
	
			base.OnClick (e);
		}
	
		private void prndoc_PrintPage(object sender, PrintPageEventArgs e)
		{
			Graphics printgr = e.Graphics;
			string message = "    ..!";
			//  
			printgr.DrawString(message, 
				this.Font, Brushes.Black, 0, 0);
			//        
			SizeF szf = printgr.MeasureString(message, this.Font);
			//        
			//       
			printgr.DrawLine(Pens.Black, szf.ToPointF(),
				printgr.VisibleClipBounds.Size.ToPointF());
		}
	}
}