using System;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Printing;
	
namespace Test
{
	public class PrintableForm : Form
	{
		public PrintableForm()
		{
			this.Text = ",  ";
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ForeColor = System.Drawing.SystemColors.WindowText;
			this.ResizeRedraw = true;
		}
	
		protected override void OnPaint(PaintEventArgs e)
		{
			//   
			//  , .  (  !)
			DoPage(e.Graphics, ForeColor, ClientSize.Width, ClientSize.Height);
	
			base.OnPaint (e);
		}
	
		protected override void OnClick(EventArgs e)
		{
			PrintDocument prndoc = new PrintDocument();
			prndoc.DocumentName = this.Text;
			//   
			prndoc.PrintPage +=new PrintPageEventHandler(prndoc_PrintPage);
			prndoc.Print(); //   (  PrintPage)
	
			base.OnClick (e);
		}
	
		private void prndoc_PrintPage(object sender, PrintPageEventArgs e)
		{
			//    
			Graphics printgr = e.Graphics;
	
			//   
			SizeF szf = printgr.VisibleClipBounds.Size;
			//   
			DoPage(printgr, Color.Black, (int)szf.Width, (int)szf.Height);
		}
	
		//        
		protected virtual void DoPage(Graphics graphics, Color color,
			int cx, int cy)
		{
			Pen pen = new Pen(color);
			//       
			graphics.DrawLine(pen, 0, 0, cx - 1, cy - 1);
			graphics.DrawLine(pen, cx - 1, 0, 0, cy - 1);
		}
	}
}
