using System;
using System.Drawing;
using System.Windows.Forms;
	
namespace Test
{
	public class RoundRect : PrintableForm
	{
		public RoundRect()
		{
			this.Text = "     (RoundRect)";
		}
	
		//     PrintableForm
		protected override void DoPage(Graphics graphics, Color color, int cx, int cy)
		{
			RoundedRectangle(graphics, Pens.Red,
				new Rectangle(0, 0, cx - 1, cy - 1),
				new Size(cx / 5, cy / 5));
		}
	
		private void RoundedRectangle(Graphics gr, Pen pn, Rectangle rect, Size sz)
		{
			gr.DrawLine(pn, rect.Left + sz.Width / 2, rect.Top,
				rect.Right - sz.Width / 2, rect.Top);
			gr.DrawArc(pn, rect.Right - sz.Width, rect.Top,
				sz.Width, sz.Height, 270, 90);
			gr.DrawLine(pn, rect.Right, rect.Top + sz.Height / 2,
				rect.Right, rect.Bottom - sz.Height / 2);
			gr.DrawArc(pn, rect.Right - sz.Width, rect.Bottom - sz.Height,
				sz.Width, sz.Height, 0, 90);
			gr.DrawLine(pn, rect.Right - sz.Width / 2, rect.Bottom,
				rect.Left + sz.Width / 2, rect.Bottom);
			gr.DrawArc(pn, rect.Left, rect.Bottom - sz.Height,
				sz.Width, sz.Height, 90, 90);
			gr.DrawLine(pn, rect.Left, rect.Bottom - sz.Height / 2,
				rect.Left, rect.Top + sz.Height / 2);
			gr.DrawArc(pn, rect.Left, rect.Top,
				sz.Width, sz.Height, 180, 90);
		}
	}
}