using System;
using System.Drawing;
using System.Windows.Forms;
	
namespace Test
{
	public class Spiral : PrintableForm
	{
		public Spiral()
		{
			this.Text = "   DrawLines()";
			this.Width += 100;
		}
	
		//     PrintableForm
		protected override void DoPage(Graphics graphics, Color color, int cx, int cy)
		{
			const int iNumRevs = 10;
			int iNumPoints = iNumRevs * 2 * (cx + cy);
			PointF[] apointf = new PointF[iNumPoints];
			double rAngle, rScale;
	
			for(int i = 0; i < iNumPoints; i++)
			{
				rAngle =  iNumRevs * i * 2 * Math.PI / iNumPoints;
				//  -   ,   
				rScale = 1 - i / Convert.ToDouble(iNumPoints);
				apointf[i].X = (float)(Convert.ToDouble(cx) / 2 * (1 + rScale * Math.Cos(rAngle)));
				apointf[i].Y = (float)(Convert.ToDouble(cy) / 2 * (1 + rScale * Math.Sin(rAngle)));
			}
	
			graphics.DrawLines(new Pen(color), apointf);
		}
	}
}